<?php

namespace ReadyApp\ExampleApp;

use ReadyCls\BgTask\IArgument;

class ReportView implements IArgument {

    /** @var int */
    private $rep_id;
    /** @var string */
    private $tableViewName;

    /**
     * @inheritDoc
     */
    public function __construct(int $rep_id = NULL, string $tableViewName = NULL) {
        if ($rep_id) {
            $this->rep_id = $rep_id;
        }
        if ($tableViewName) {
            $this->tableViewName = $tableViewName;
        }
    }

    /**
     * @return int
     */
    public function getId(): int {
        return $this->rep_id;
    }

    /**
     * @inheritDoc
     */
    public function setUp(array $data): void {
        $this->rep_id = $data['rep_id'];
        $this->tableViewName = $data['tableViewName'];
    }

    /**
     * @inheritDoc
     */
    public function toArray(): array {
        return [
            'rep_id'        => $this->rep_id,
            'tableViewName' => $this->tableViewName,
        ];
    }

    /**
     * @return string
     */
    public function getTableViewName(): ?string {
        return $this->tableViewName;
    }

}